function [s_p] = EntropicProj_opt(A,b,s0)

%% Entropic Projection function
% This function solves the A*s_p=b problem using the entropic functional
% based cost function. (Optimizationm toolbox based method)
%INPUT
%A : a 1xN row vector
%s0: a Nx1 column vector
%b : scalar

%OUTPUT
%s_p = Nx1 column Vector

base = exp(1);
options = optimset('display','off','MaxIter',10000,'MaxFunEvals',500000);
[s_p,~] = fmincon(@(x)objfun5(x,s0),s0,[],[],A,b,[],[],[],options);
%[s_p1,fval1] = fmincon(@(x)objfun6(x,s0,base),s0,[],[],A,b,[],[],[],options);



function [D] = objfun5(s,s0)

g = sum((abs(s)+exp(-1)).*log(abs(s)+exp(-1))+exp(-1));
g0 = sum((abs(s0)+exp(-1)).*log(abs(s0)+exp(-1))+exp(-1));
dg = sign(s).*(log(abs(s)+exp(-1))+1);
d = s-s0;

D =-1*((g)-(g0)-(dg'*d));

function [D] = objfun6(s,s0,base)

g = sum((abs(s)+exp(-1)).*(log(abs(s)+exp(-1))/log(base))+(exp(-1)/log(base)));
g0 = sum((abs(s0)+exp(-1)).*(log(abs(s0)+exp(-1))/log(base))+(exp(-1)/log(base)));
dg = (sign(s)/log(base)).*(log(abs(s)+exp(-1))+1);
d = s-s0;

D =-1*((g)-(g0)-(dg'*d));