function [Sp] = L1Proj(A,b,S0)

%Solves
%min ||S0-Sp||_1 s.t. A*S=b problem by projecting Sinit onto the defined hyperplane
%
%Sinit : Column Vector of size Nx1
%        or Matrix of NxM (each column is a point to project)
%A     : Row Vector of Size 1XN
%b     : 1x1 bound
%
%Note: This version supports only one hyperplane projection at a time

indx = find(abs(A) == max(abs(A)),1,'first');
err = b-A*S0;
shortage = err/A(indx);
Sp = S0;
Sp(indx) = Sp(indx)+shortage;