function [Sp] = L2Proj(A,b,S0)

%Solves
%min ||S0-Sp||_2 s.t. A*S=b problem by projecting Sinit onto the defined hyperplane
%
%Sinit : Column Vector of size Nx1 
%        or Matrix of NxM (each column is a point to project)
%A     : Row Vector of Size 1XN
%b     : 1x1 bound
%
%Note: This version supports only one hyperplane projection at a time

lambda = ((b)-A*S0)./sum((A.*A));
Sp = (S0' + lambda'*(A))';